commit 361a13a1bc9204a224acf26ed1d88db0d709109a
Author: freddy77 <freddy77>
Date:   Fri Oct 16 07:59:39 2009 +0000

    Fix dbwritetext with text == NULL

diff --git a/ChangeLog b/ChangeLog
index 2e84fe5..1ec8e0b 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Fri Oct 16 09:58:46 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/dblib/dblib.c: Fix dbwritetext with text == NULL
+
 Mon Oct 12 09:26:46 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* misc/prepare_win32.sh:
 	- add comments to misc/prepare_win32.sh script
@@ -1871,4 +1874,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2878 2009/10/12 07:27:50 freddy77 Exp $
+$Id: ChangeLog,v 1.2879 2009/10/16 07:59:39 freddy77 Exp $
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index 15956f3..cea010b 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -75,7 +75,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.353 2009/09/01 08:02:36 freddy77 Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.354 2009/10/16 07:59:40 freddy77 Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -4551,8 +4551,10 @@ dbsqlok(DBPROCESS * dbproc)
 
 	tds = dbproc->tds_socket;
 
-	/* dbsqlok has been called after dbmoretext() */
-	/* This is the trigger to send the text data. */
+	/*
+	 * dbsqlok has been called after dbmoretext()
+	 * This is the trigger to send the text data.
+	 */
 
 	if (dbproc->text_sent) {
 		tds_flush_packet(tds);
@@ -6298,7 +6300,6 @@ dbwritetext(DBPROCESS * dbproc, char *objname, DBBINARY * textptr, DBTINYINT tex
 	CHECK_NULP(textptr, "dbwritetext", 3, FAIL);
 	CHECK_NULP(timestamp, "dbwritetext", 5, FAIL);
 	CHECK_PARAMETER(size, SYBEZTXT, FAIL);
-	CHECK_NULP(text, "dbwritetext", 8, FAIL);
 
 	if (IS_TDSDEAD(dbproc->tds_socket))
 		return FAIL;
@@ -6332,6 +6333,7 @@ dbwritetext(DBPROCESS * dbproc, char *objname, DBBINARY * textptr, DBTINYINT tex
 
 	tds_writetext_continue(dbproc->tds_socket, text, size);
 	tds_writetext_end(dbproc->tds_socket);
+	dbproc->text_sent = 0;
 
 	if (dbsqlok(dbproc) == SUCCEED && dbresults(dbproc) == SUCCEED)
 		return SUCCEED;
@@ -6440,8 +6442,10 @@ dbmoretext(DBPROCESS * dbproc, DBINT size, const BYTE text[])
 			return FAIL;
 		dbproc->text_sent += size;
 
-		if (dbproc->text_sent == dbproc->text_size)
+		if (dbproc->text_sent == dbproc->text_size) {
 			tds_writetext_end(dbproc->tds_socket);
+			dbproc->text_sent = 0;
+		}
 	}
 
 	return SUCCEED;

